// "@(#)$RCSfile: sdi_shp_arr.hxx,v $ $Revision: 1.4 $ $AVS$ $Date: 1998/03/09 13:17:11 $"
//
//		Copyright (c) 1994 by
//		Advanced Visual Systems Inc.
//		All Rights Reserved
//	
//	This software comprises unpublished confidential information of
//	Advanced Visual Systems Inc. and may not be used, copied or made
//	available to anyone, except in accordance with the license
//	under which it is furnished.
//	
//	This file is under sccs control at AVS in:
//	$Source: /cvs/repository/sdi/sdiproj/sdi/sdi_shp_arr.hxx,v $
//

//
// file: sdi_shp_arr.hxx
// author: Dave Goughnour, Advanced Visual System
// purpose: Maintain an array (actually a linked list) of shapes
//
#ifndef SDI_SHP_ARR_DEFINED
#define SDI_SHP_ARR_DEFINED
#include "sdi_shape.hxx"

// define SDI_Shape_Entry class
//
class SDI_Shape_Entry : public SDI_Shape {
public:
   // Constructors
   //
   SDI_Shape_Entry( SDI_Shape_Entry *previous, SDI_Shape_Entry *next );
   SDI_Shape_Entry( SDI_Shape &shape, SDI_Shape_Entry *previous, SDI_Shape_Entry *next );
   
   // Destructor
   //
   ~SDI_Shape_Entry();

   // Get next and previous
   //
   SDI_Shape_Entry *GetNext()
      { return( next ); }

   SDI_Shape_Entry *GetPrevious()
      { return( previous ); }

private:
   SDI_Shape_Entry *previous;
   SDI_Shape_Entry *next;
};

// Define SDI_Shape_Array class which maintains a list of entries
//
class SDI_Shape_Array {
public:
   // Constructor
   //
   SDI_Shape_Array();

   // Destructor
   //
   virtual ~SDI_Shape_Array();

   // Basic setup
   //
   void SetName( char *name );
   void SetFieldName( char *name );

   // Add shapes to list
   //
   SDI_Shape *Add();
   SDI_Shape *Add( SDI_Shape &shape );

   // Get specified shape from list
   //
   SDI_Shape *Get( int index );

   // Delete a shape from the list
   //
   void Delete( SDI_Shape *entry );

   // Return number of entries in list
   //
   int GetNumEntries() 
      { return num_entries; }
  
private:
   int num_entries;
   SDI_Shape_Entry *first;
   SDI_Shape_Entry *last;

   // Create private copy constructor and assignment operator 
   // to invalidate copys and assignments
   //
   SDI_Shape_Array( const SDI_Shape_Array & ) {}
   SDI_Shape_Array &operator=(const SDI_Shape_Array &) { return *this; }
};
#endif

